on error resume next
Dim printStr

Set objFSO = CreateObject("Scripting.FileSystemObject")

Sub print_log(ByRef msg)
	WScript.Echo msg
End Sub

Sub get_hbaport_state(ByRef ps)
	Select Case ps 
		Case 1 printStr="[1] HBA_PORTSTATE_UNKNOWN (Unknown.)" 
		Case 2 printStr="[2] HBA_PORTSTATE_ONLINE (Operational.)" 
		Case 3 printStr="[3] HBA_PORTSTATE_OFFLINE (User Offline)" 
		Case 4 printStr="[4] HBA_PORTSTATE_BYPASSED (Bypassed.)" 
		Case 5 printStr="[5] HBA_PORTSTATE_DIAGNOSTICS (In diagnostics mode.)" 
		Case 6 printStr="[6] HBA_PORTSTATE_LINKDOWN (Link Down)" 
		Case 7 printStr="[7] HBA_PORTSTATE_ERROR (Port Error.)" 
		Case 8 printStr="[8] HBA_PORTSTATE_LOOPBACK (Loopback.)" 
		Case Else printStr="Unkown"
	End Select 
End Sub

Sub get_hbastate(ByRef ps)
	printStr=""
	Select Case ps 
		Case 0 printStr="HBA_STATUS_OK" 
		Case Else printStr="Error Code:" & ps
	End Select 
End Sub

Sub support_speed(ByRef s)
	Select Case s 
		Case 1 printStr=printStr & "|HBA_PORTSPEED_1GBIT" 
		Case 2 printStr=printStr & "|HBA_PORTSPEED_2GBIT" 
		Case 3 printStr=printStr & "|HBA_PORTSPEED_10GBIT" 
		Case 4 printStr=printStr & "|HBA_PORTSPEED_4GBIT" 
		Case 5 printStr=printStr & "|HBA_PORTSPEED_8GBIT"
		case Else printStr=printStr & "|unacquainted"
	End Select 
End Sub

Sub get_hbaport_speed(ByRef ps)
	Dim qz,qy,count
	
	printStr=""
	qz=ps
	count=1
	Do While qz <> 0 
		qy = qz Mod 2
		qz = qz \ 2
		If qy = 1 Then
			support_speed(count)
		End If
		count=count+1
	Loop

End Sub 

Sub get_hbaport_type(ByRef pt)
	Select Case pt 
		Case 1 printStr="[1] HBA_PORTTYPE_UNKNOWN(Unknown port type.)" 
		Case 2 printStr="[2] HBA_PORTTYPE_OTHER(Value that is not a port type. )" 
		Case 3 printStr="[3] HBA_PORTTYPE_NOTPRESENT(Port not present.)" 
		Case 5 printStr="[5] HBA_PORTTYPE_NPORT(Fabric. )" 
		Case 6 printStr="[6] HBA_PORTTYPE_NLPORT(Public loop.)" 
		Case 7 printStr="[7] HBA_PORTTYPE_FLPORT(Fabric on a loop.)" 
		Case 8 printStr="[8] HBA_PORTTYPE_FPORT(Fabric port.)" 
		Case 9 printStr="[9] HBA_PORTTYPE_EPORT(Fabric expansion port. )" 
		Case 10 printStr="[10] HBA_PORTTYPE_GPORT(Generic Fabric. )" 
		Case 20 printStr="[20] HBA_PORTTYPE_LPORT(Private loop port. )" 
		Case 21 printStr="[21] HBA_PORTTYPE_PTP(Point to point. )" 
		Case Else printStr="Unkown"
	End Select 
End Sub

'--------------------------------------------------------------------------------
Set objWMIService = GetObject( _
    "winmgmts:\\.\root\WMI")
Set colItems = objWMIService.ExecQuery( _
    "Select * from MSFC_FCAdapterHBAAttributes")

print_log "[HBA Adapter Attributes]"

nodewwn=""
For Each objItem in colItems
	print_log "-----------------------------------------------"
    print_log "UniqueAdapterId		:" & CStr(objItem.UniqueAdapterId)
	print_log "SerialNumber 		:" & objItem.SerialNumber  
	For i=0 To UBound(objItem.NodeWWN)
		If i = 0 Then
			nodewwn=hex(objItem.NodeWWN(i))
		Else
			nodewwn=nodewwn & ":" & hex(objItem.NodeWWN(i))
		End If
	Next
	print_log "NodeWWN			:" & nodewwn
	print_log "Model			:" & objItem.Model
	print_log "ModelDescription	:" & objItem.ModelDescription
	print_log "NodeSymbolicName 	:" & objItem.NodeSymbolicName 
	print_log "DriverName		:" & objItem.DriverName   
	print_log "DriverVersion		:" & objItem.DriverVersion
	print_log "FirmwareVersion		:" & objItem.FirmwareVersion
	print_log "HardwareVersion		:" & objItem.HardwareVersion
	print_log "OptionROMVersion	:" & objItem.OptionROMVersion
	print_log "MfgDomain		:" & objItem.MfgDomain  
	print_log "Manufacturer		:" & objItem.Manufacturer
	print_log "VendorSpecificID 	:" & objItem.VendorSpecificID 
    print_log "NumberOfPorts		:" & objItem.NumberOfPorts 
	get_hbastate(objItem.HBAStatus)
	print_log "HBAStatus		:" & printStr
	print_log "-----------------------------------------------"
Next

print_log "[/HBA Adapter Attributes]"
print_log ""
'---------------------------------------------------------------------------------

print_log "[FC Port Attributes]"
Set colItems = objWMIService.ExecQuery( _
    "Select * from MSFC_FibrePortHBAAttributes ")
	
For Each objItem in colItems
	print_log "-----------------------------------------------"
	print_log "UniquePortId 			:" & objItem.UniquePortId
	get_hbastate(objItem.HBAStatus)
	print_log "HBAStatus 			:" & printStr
	print_log "Attributes.PortFcId 		:" & objItem.Attributes.PortFcId
	
	get_hbaport_type(objItem.Attributes.PortType)
	print_log "Attributes.PortType 		:" & printStr
	get_hbaport_state(objItem.Attributes.PortState)
	print_log "Attributes.PortState 		:" & printStr
	
	nodewwn=""
	For i=0 To UBound(objItem.Attributes.NodeWWN)
		If i = 0 Then
			nodewwn=hex(objItem.Attributes.NodeWWN(i))
		Else
			nodewwn=nodewwn & ":" & hex(objItem.Attributes.NodeWWN(i))
		End If
	Next
	print_log "Attributes.NodeWWN 		:" & nodewwn
	
	nodewwn=""
	For i=0 To UBound(objItem.Attributes.PortWWN)
		If i = 0 Then
			nodewwn=hex(objItem.Attributes.PortWWN(i))
		Else
			nodewwn=nodewwn & ":" & hex(objItem.Attributes.PortWWN(i))
		End If
	Next
	print_log "Attributes.PortWWN 		:" & nodewwn
	print_log "Attributes.PortSupportedClassofService 	:" & objItem.Attributes.PortSupportedClassofService

	nodewwn=""
	For i=0 To UBound(objItem.Attributes.PortSupportedFc4Types)
		If i = 0 Then
			nodewwn=hex(objItem.Attributes.PortSupportedFc4Types)
		Else
			nodewwn=nodewwn & " " & hex(objItem.Attributes.PortSupportedFc4Types)
		End If
	Next
	print_log "Attributes.PortSupportedFc4Types 	:" & nodewwn

	nodewwn=""
	For i=0 To UBound(objItem.Attributes.PortActiveFc4Types)
		If i = 0 Then
			nodewwn=hex(objItem.Attributes.PortActiveFc4Types)
		Else
			nodewwn=nodewwn & " " & hex(objItem.Attributes.PortActiveFc4Types)
		End If
	Next
	print_log "Attributes.PortActiveFc4Types		:" & nodewwn
	
	get_hbaport_speed(objItem.Attributes.PortSupportedSpeed)
	print_log "Attributes.PortSupportedSpeed 		:0x" & hex(objItem.Attributes.PortSupportedSpeed) & " " & printStr
	
	get_hbaport_speed(objItem.Attributes.PortSpeed)
	print_log "Attributes.PortSpeed			:0x" & hex(objItem.Attributes.PortSpeed)  & " " & printStr
	
	print_log "Attributes.PortMaxFrameSize		:" & objItem.Attributes.PortMaxFrameSize

	nodewwn=""
	For i=0 To UBound(objItem.Attributes.FabricName)
		If i = 0 Then
			nodewwn=hex(objItem.Attributes.FabricName(i))
		Else
			nodewwn=nodewwn & ":" & hex(objItem.Attributes.FabricName(i))
		End If
	Next
	print_log "Attributes.FabricName 			:" & nodewwn
	print_log "Attributes.NumberofDiscoveredPorts 	:" & objItem.Attributes.NumberofDiscoveredPorts	
	print_log "-----------------------------------------------"
Next

print_log "[/FC Port Attributes]"
print_log ""
'------------------------------------------------------------------------------------------------
 
print_log "[FC Port Statistics]"
Set colItems = objWMIService.ExecQuery( _
    "Select * from MSFC_FibrePortHBAStatistics ")

For Each objItem in colItems
	print_log "-----------------------------------------------"
	print_log "UniquePortId 				:" & objItem.UniquePortId
	get_hbastate(objItem.HBAStatus)
	print_log "HBAStatus 				:" & printStr
	
	print_log "Statistics.SecondsSinceLastReset 	:" & objItem.Statistics.SecondsSinceLastReset
	print_log "Statistics.TxFrames 			:" & objItem.Statistics.TxFrames
	print_log "Statistics.TxWords 			:" & objItem.Statistics.TxWords
	print_log "Statistics.RxFrames 			:" & objItem.Statistics.RxFrames
	print_log "Statistics.RxWords 			:" & objItem.Statistics.RxWords
	print_log "Statistics.LIPCount 			:" & objItem.Statistics.LIPCount
	print_log "Statistics.NOSCount 			:" & objItem.Statistics.NOSCount
	print_log "Statistics.ErrorFrames 			:" & objItem.Statistics.ErrorFrames
	print_log "Statistics.DumpedFrames 		:" & objItem.Statistics.DumpedFrames
	print_log "Statistics.LinkFailureCount 		:" & objItem.Statistics.LinkFailureCount
	print_log "Statistics.LossOfSyncCount 		:" & objItem.Statistics.LossOfSyncCount
	print_log "Statistics.LossOfSignalCount 		:" & objItem.Statistics.LossOfSignalCount
	print_log "Statistics.PrimitiveSeqProtocolErrCount :" & objItem.Statistics.PrimitiveSeqProtocolErrCount
	print_log "Statistics.InvalidTxWordCount 		:" & objItem.Statistics.InvalidTxWordCount
	print_log "Statistics.InvalidCRCCount 		:" & objItem.Statistics.InvalidCRCCount
	print_log "-----------------------------------------------"
Next

print_log "[/FC Port Statistics]"
print_log ""
'------------------------------------------------------------------------------------------------

print_log "[NPIVLUNMappingInformation]"

Set colItems = objWMIService.ExecQuery( _
    "Select * from MSFC_NPIVLUNMappingInformation ")

For Each objItem in colItems
	print_log "-----------------------------------------------"
	nodewwn=""
	For i=0 To UBound(objItem.WWPNVirtualPort)
		If i = 0 Then
			nodewwn=hex(objItem.WWPNVirtualPort(i))
		Else
			nodewwn=nodewwn & ":" & hex(objItem.WWPNVirtualPort(i))
		End If
	Next
	print_log "WWPNVirtualPort 	:" & nodewwn
	
	nodewwn=""
	For i=0 To UBound(objItem.WWPNPhysicalPort)
		If i = 0 Then
			nodewwn=hex(objItem.WWPNPhysicalPort(i))
		Else
			nodewwn=nodewwn & ":" & hex(objItem.WWPNPhysicalPort(i))
		End If
	Next
	print_log "WWPNPhysicalPort 	:" & nodewwn	
	
	print_log "OSBus 			:" & objItem.OSBus
	print_log "OSTarget 		:" & objItem.OSTarget
	print_log "OSLUN 			:" & objItem.OSLUN
	print_log "-----------------------------------------------"
Next

print_log "[/NPIVLUNMappingInformation]"
