# coding=utf-8
__author__ = '******'
# 获取linux主机的集群信息
import re
CLI = None
LANGUAGE = None
CHECK_FAIL          =       0
CHECK_PASS          =       1
cmd_info_id = [
               "cmd_info_cluster_findrac",
               "cmd_info_cluster_findhacmp",
               "cmd_info_cluster_defaulthacmp",
               ]
            
cmd_info_desc = [
                 "find / -name crs_stat",
                 "find / -name clstat",
                 "/usr/sbin/cluster/clstat",
                 ]


def execute(context):
    """
    Function name      : execute
    Function describe  : 外部接入
    Input              : context
    Return             : cmd display
    """
    # 给全局变量赋初始值，按照要求传递上下文进去。
    global CLI
    CLI = context.get("SSH")
    global LANGUAGE
    LANGUAGE = context.get("lang")
    cmd_display = context.get("ret_map")
    add_rac_cluster(CLI)
    
    return check_and_get_result(cmd_execute(cmd_display, CLI, LANGUAGE))


# 取中间一个有效值
def check_and_get_result((fun_flag, result, fun_err_msg)):
    """
    :rtype : object
    """
    return result

def add_rac_cluster(CLI):
    findResult = CLI.execCmdHasLogTimout("find / -name crs_stat",60).splitlines()
    if len(findResult[1:]) == 0:
        return
    for line in findResult[1:]:
        if "crs_stat" in line:
            cmd_info_id.append("cmd_info_cluster_racstat")
            cmd_info_desc.append(line+" -t")
            cmd_info_id.append("cmd_info_cluster_raccrsctl")
            cmd_info_desc.append(line.replace('crs_stat','crsctl')+" check crs")
            cmd_info_id.append("cmd_info_cluster_votedisk")
            cmd_info_desc.append(line.replace('crs_stat','crsctl')+" query css votedisk")
            cmd_info_id.append("cmd_info_cluster_databaseorccheck")
            cmd_info_desc.append(line.replace('crs_stat','ocrcheck'))
            
            break

def add_hacmp_cluster(CLI):
    findResult = CLI.execCmdHasLogTimout("find / -name clstat",60).splitlines()
    if len(findResult[1:]) == 0:
        return
    for line in findResult[1:]:
        if 'clstat' in line:
            cmd_info_id.append("cmd_info_cluster_hacmp")
            cmd_info_desc.append(line)
            
            break
        

def cmd_execute(cmd_display, CLI, LANGUAGE):
    fun_flag = CHECK_FAIL
    fun_err_msg = ''
    for rg in range(len(cmd_info_id)):
        cmd_display_temp = CLI.execCmdHasLogTimout(cmd_info_desc[rg],60)
        cmd_display.put("cmd_display"+(cmd_info_id[rg])[8:], cmd_display_temp)
        if None == cmd_display_temp or '' == cmd_display_temp or cmd_display_temp.find('TOOLKIT_SEND_CMD_TIME_OUT') > 0 or cmd_display_temp.find('TOOLKIT_EXE_CMD_FAILED') > 0:
            if "en"==LANGUAGE:
                fun_err_msg        +=cmd_info_desc[rg] + ":\texecute failed\r\n"
            else:
                fun_err_msg        +=cmd_info_desc[rg] + u":\t执行失败\r\n"
        else:
            if "en"==LANGUAGE:
                fun_err_msg        +=cmd_info_desc[rg] + ":\texecute success\r\n"
            else:
                fun_err_msg        +=cmd_info_desc[rg] + u":\t执行成功\r\n"
    cmd_display.put("err_msg", fun_err_msg)
    fun_flag = CHECK_PASS
    return fun_flag, cmd_display, fun_err_msg