# coding=utf-8
__author__ = '******'
# 获取aix主机的磁盘管理信息
import re
CLI = None
LANGUAGE = None
CHECK_FAIL          =       0
CHECK_PASS          =       1
cmd_info_id = ["cmd_info_disk_mgt_lsdev_disk"            ,
               "cmd_info_disk_mgt_lspv"                  ,
               "cmd_info_disk_mgt_lsattr_el"             ,
               "cmd_info_disk_mgt_bootinfo_hdisk"        ,
               "cmd_info_disk_mgt_ls_dev"                ,
               "cmd_info_disk_mgt_lspv_u"                ]
            
cmd_info_desc = ["lsdev -Cc disk",
                 "lspv",
                 "lsattr -El ",
                 "bootinfo -s ",
                 "ls -al /dev/*",
                 "lspv -u"]
            
cmd_info_disk_list = "lsdev -Cc disk|awk '{print $1}'"


def execute(context):
    """
    Function name      : execute
    Function describe  : 外部接入
    Input              : context
    Return             : cmd display
    """
    # 给全局变量赋初始值，按照要求传递上下文进去。
    global CLI
    CLI = context.get("SSH")
    global LANGUAGE
    LANGUAGE = context.get("lang")
    cmd_display = context.get("ret_map")
    return check_and_get_result(cmd_execute(cmd_display, CLI, LANGUAGE))


# 取中间一个有效值
def check_and_get_result((fun_flag, result, fun_err_msg)):
    """
    :rtype : object
    """
    return result


def cmd_execute(cmd_display, CLI, LANGUAGE):
    fun_flag = CHECK_FAIL
    fun_err_msg = ''
    disk_list = CLI.execCmdHasLog(cmd_info_disk_list).splitlines()
    for rg in range(len(cmd_info_id)):
        if cmd_info_id[rg]=="cmd_info_disk_mgt_lsattr_el" or cmd_info_id[rg]=="cmd_info_disk_mgt_bootinfo_hdisk":
            for disk in disk_list[1:]:
                cmd_display_temp=CLI.execCmdHasLogTimout(cmd_info_desc[rg] + disk,60)
                cmd_display.put("cmd_display"+(cmd_info_id[rg])[8:]+"_" +disk, cmd_display_temp)
                if None == cmd_display_temp or '' == cmd_display_temp or cmd_display_temp.find('TOOLKIT_SEND_CMD_TIME_OUT') > 0 or cmd_display_temp.find('TOOLKIT_EXE_CMD_FAILED') > 0:
                    if "en"==LANGUAGE:
                        fun_err_msg        +=cmd_info_desc[rg] + disk + ":\texecute failed\r\n"
                    else:
                        fun_err_msg        +=cmd_info_desc[rg] + disk + u":\t执行失败\r\n"
                else:
                    if "en"==LANGUAGE:
                        fun_err_msg        +=cmd_info_desc[rg] + disk + ":\texecute success\r\n"
                    else:
                        fun_err_msg        +=cmd_info_desc[rg] + disk + u":\t执行成功\r\n"
        else:
            cmd_display_temp = CLI.execCmdHasLogTimout(cmd_info_desc[rg],60)
            cmd_display.put("cmd_display"+(cmd_info_id[rg])[8:], cmd_display_temp)
            if None == cmd_display_temp or '' == cmd_display_temp or cmd_display_temp.find('TOOLKIT_SEND_CMD_TIME_OUT') > 0 or cmd_display_temp.find('TOOLKIT_EXE_CMD_FAILED') > 0:
                if "en"==LANGUAGE:
                    fun_err_msg        +=cmd_info_desc[rg] + ":\texecute failed\r\n"
                else:
                    fun_err_msg        +=cmd_info_desc[rg] + u":\t执行失败\r\n"
            else:
                if "en"==LANGUAGE:
                    fun_err_msg        +=cmd_info_desc[rg] + ":\texecute success\r\n"
                else:
                    fun_err_msg        +=cmd_info_desc[rg] + u":\t执行成功\r\n"
    cmd_display.put("err_msg", fun_err_msg)
    fun_flag = CHECK_PASS
    return fun_flag, cmd_display, fun_err_msg