# coding=utf-8
__author__ = '******'
# 获取linux主机的逻辑卷信息
import re
import sys
import os
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..")
sys.path.append(path)
from common import util
from common import constants
CLI = None
LANGUAGE = None
CHECK_FAIL          =       0
CHECK_PASS          =       1
cmd_info_id = ["cmd_info_logic_volune_lslpp_l_vxvm"      ,
               "cmd_info_logic_volune_lsvg"         ,
               "cmd_info_logic_volune_lspv"         ,
               "cmd_info_logic_volune_lsvg_vgname_vgsize"  ,
               "cmd_info_logic_volune_lsvg_vgname_l",
               "cmd_info_logic_volune_lsvg_vgname_p",
               "cmd_info_logic_volune_lspv_pvname"  ,
               "cmd_info_logic_volune_lspv_pvname_l",
               "cmd_info_logic_volune_lslv_lvname"  ,
               "cmd_info_logic_volune_lslv_lvname_m"]
            
cmd_info_desc = ["lslpp -l | grep vxvm",
                 "lsvg",
                 "lspv",
                 "lsvg ",
                 "lsvg -l ",
                 "lsvg -p ",
                 "lspv ",
                 "lspv -l ",
                 "lslv ",
                 "lslv -m "]
            
cmd_info_vg_list = "lsvg"
cmd_info_pv_list = "lspv|grep active|awk '{print $1}'"
cmd_info_lv_list = "lsdev|grep 'Logical volume'|awk '{print $1}'"


def execute(context):
    """
    Function name      : execute
    Function describe  : 外部接入
    Input              : context
    Return             : cmd display
    """
    # 给全局变量赋初始值，按照要求传递上下文进去。
    global CLI
    CLI = context.get("SSH")
    global LANGUAGE
    LANGUAGE = context.get("lang")
    cmd_display = context.get("ret_map")
    return check_and_get_result(cmd_execute(cmd_display, CLI, LANGUAGE,context))


# 取中间一个有效值
def check_and_get_result((fun_flag, result, fun_err_msg)):
    """
    :rtype : object
    """
    return result


def cmd_execute(cmd_display, CLI, LANGUAGE,context):
    fun_flag = CHECK_FAIL
    fun_err_msg = ''
    vg_list = CLI.execCmdHasLog(cmd_info_vg_list).splitlines()
    util.updateItemProgress(context, constants.PROG5)
    pv_list = CLI.execCmdHasLog(cmd_info_pv_list).splitlines()
    util.updateItemProgress(context, constants.PROG10)
    lv_list = CLI.execCmdHasLog(cmd_info_lv_list).splitlines()
    util.updateItemProgress(context, constants.PROG15)
    totalCmd = len(vg_list) + len(pv_list) + len(lv_list) + len(cmd_info_id)
    prgStep = constants.PROG75 / totalCmd
    curstep = constants.PROG15
    for rg in range(len(cmd_info_id)):
        if cmd_info_id[rg]=="cmd_info_logic_volune_lsvg_vgname" or cmd_info_id[rg]=="cmd_info_logic_volune_lsvg_vgname_l" or cmd_info_id[rg]=="cmd_info_logic_volune_lsvg_vgname_p":
            for vgname in vg_list[1:]:
                cmd_display_temp=CLI.execCmdHasLogTimout(cmd_info_desc[rg] + vgname,60)
                curstep += prgStep
                util.updateItemProgress(context, curstep)
                cmd_display.put("cmd_display"+(cmd_info_id[rg])[8:]+"_"+vgname, cmd_display_temp)
                if None == cmd_display_temp or '' == cmd_display_temp or cmd_display_temp.find('TOOLKIT_SEND_CMD_TIME_OUT') > 0 or cmd_display_temp.find('TOOLKIT_EXE_CMD_FAILED') > 0:
                    if "en"==LANGUAGE:
                        fun_err_msg        +=cmd_info_desc[rg] + vgname + ":\texecute failed\r\n"
                    else:
                        fun_err_msg        +=cmd_info_desc[rg] + vgname + u":\t执行失败\r\n"
                else:
                    if "en"==LANGUAGE:
                        fun_err_msg        +=cmd_info_desc[rg] + vgname + ":\texecute success\r\n"
                    else:
                        fun_err_msg        +=cmd_info_desc[rg] + vgname + u":\t执行成功\r\n"
        elif cmd_info_id[rg]=="cmd_info_logic_volune_lspv_pvname" or cmd_info_id[rg]=="cmd_info_logic_volune_lspv_pvname_l":
            for pvname in pv_list[1:]:
                cmd_display_temp=CLI.execCmdHasLogTimout(cmd_info_desc[rg] + pvname,60)
                curstep += prgStep
                util.updateItemProgress(context, curstep)
                cmd_display.put("cmd_display"+(cmd_info_id[rg])[8:]+"_"+pvname, cmd_display_temp)
                if None == cmd_display_temp or '' == cmd_display_temp or cmd_display_temp.find('TOOLKIT_SEND_CMD_TIME_OUT') > 0 or cmd_display_temp.find('TOOLKIT_EXE_CMD_FAILED') > 0:
                    if "en"==LANGUAGE:
                        fun_err_msg        +=cmd_info_desc[rg] + pvname + ":\texecute failed\r\n"
                    else:
                        fun_err_msg        +=cmd_info_desc[rg] + pvname + u":\t执行失败\r\n"
                else:
                    if "en"==LANGUAGE:
                        fun_err_msg        +=cmd_info_desc[rg] + pvname + ":\texecute success\r\n"
                    else:
	                    fun_err_msg        +=cmd_info_desc[rg] + pvname + u":\t执行成功\r\n"
        elif cmd_info_id[rg]=="cmd_info_logic_volune_lslv_lvname" or cmd_info_id[rg]=="cmd_info_logic_volune_lslv_lvname_m":
            for lvname in lv_list[1:]:
                cmd_display_temp=CLI.execCmdHasLogTimout(cmd_info_desc[rg] + lvname,60)
                curstep += prgStep
                util.updateItemProgress(context, curstep)
                cmd_display.put("cmd_display"+(cmd_info_id[rg])[8:]+"_"+lvname, cmd_display_temp)
                if None == cmd_display_temp or '' == cmd_display_temp or cmd_display_temp.find('TOOLKIT_SEND_CMD_TIME_OUT') > 0 or cmd_display_temp.find('TOOLKIT_EXE_CMD_FAILED') > 0:
                    if "en"==LANGUAGE:
                        fun_err_msg        +=cmd_info_desc[rg] + lvname + ":\texecute failed\r\n"
                    else:
                        fun_err_msg        +=cmd_info_desc[rg] + lvname + u":\t执行失败\r\n"
                else:
                    if "en"==LANGUAGE:
                        fun_err_msg        +=cmd_info_desc[rg] + lvname + ":\texecute success\r\n"
                    else:
                        fun_err_msg        +=cmd_info_desc[rg] + lvname + u":\t执行成功\r\n"
        else:
            cmd_display_temp = CLI.execCmdHasLogTimout(cmd_info_desc[rg],60)
            curstep += prgStep
            util.updateItemProgress(context, curstep)
            cmd_display.put("cmd_display"+(cmd_info_id[rg])[8:], cmd_display_temp)
            if None == cmd_display_temp or '' == cmd_display_temp or cmd_display_temp.find('TOOLKIT_SEND_CMD_TIME_OUT') > 0 or cmd_display_temp.find('TOOLKIT_EXE_CMD_FAILED') > 0:
                if "en"==LANGUAGE:
                    fun_err_msg        +=cmd_info_desc[rg] + ":\texecute failed\r\n"
                else:
                    fun_err_msg        +=cmd_info_desc[rg] + u":\t执行失败\r\n"
            else:
                if "en"==LANGUAGE:
                    fun_err_msg        +=cmd_info_desc[rg] + ":\texecute success\r\n"
                else:
                    fun_err_msg        +=cmd_info_desc[rg] + u":\t执行成功\r\n"
    cmd_display.put("err_msg", fun_err_msg)
    fun_flag = CHECK_PASS
    return fun_flag, cmd_display, fun_err_msg