# coding=utf-8
__author__ = '******'
# 获取linux主机的一些基础信息:名称、版本、CPU、内存等.
import re
import sys
import os
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..")
sys.path.append(path)
from common import util
from common import constants
CLI = None
LANGUAGE = None
CHECK_FAIL          =       0
CHECK_PASS          =       1
cmd_info_id = ["cmd_info_os_basic_uname",
               "cmd_info_os_basic_issue",
               "cmd_info_os_basic_release",
               "cmd_info_os_basic_cpu",
               "cmd_info_os_basic_mem",
               "cmd_info_os_basic_date",
               "cmd_info_os_basic_manufacturer",
               "cmd_info_os_basic_arch"
               ]
            
cmd_info_desc = ["uname -a",
                 "cat /etc/issue",
                 "cat /etc/*-release",
                 "cat /proc/cpuinfo",
                 "cat /proc/meminfo",
                 "date",
                 "dmidecode -s system-manufacturer",
                 "arch"
                 ]


def execute(context):
    """
    Function name      : execute
    Function describe  : 外部接入
    Input              : context
    Return             : cmd display
    """
    # 给全局变量赋初始值，按照要求传递上下文进去。
    global CLI
    CLI = context.get("SSH")
    global LANGUAGE
    LANGUAGE = context.get("lang")
    cmd_display = context.get("ret_map")
    return check_and_get_result(cmd_execute(cmd_display, CLI, LANGUAGE, context))


# 取中间一个有效值
def check_and_get_result((fun_flag, result, fun_err_msg)):
    """
    :rtype : object
    """
    return result


def cmd_execute(cmd_display, CLI, LANGUAGE, context):
    fun_flag = CHECK_FAIL
    fun_err_msg = ''
    util.updateItemProgress(context, constants.PROG5)
    prgStep = constants.PROG80 / len(cmd_info_id)
    curstep = constants.PROG5
    util.updateItemProgress(context, curstep)
    for rg in range(len(cmd_info_id)):
        cmd_display_temp = CLI.execCmdHasLogTimout(cmd_info_desc[rg],60)
        curstep += prgStep
        util.updateItemProgress(context, curstep)
        cmd_display.put("cmd_display"+(cmd_info_id[rg])[8:], cmd_display_temp)
        
        if None == cmd_display_temp or '' == cmd_display_temp or cmd_display_temp.find('TOOLKIT_SEND_CMD_TIME_OUT') > 0 or cmd_display_temp.find('TOOLKIT_EXE_CMD_FAILED') > 0:
            if "en"==LANGUAGE:
                fun_err_msg        +=cmd_info_desc[rg] + ":\texecute failed\r\n"
            else:
                fun_err_msg        +=cmd_info_desc[rg] + u":\t执行失败\r\n"
        else:
            if "en"==LANGUAGE:
                fun_err_msg        +=cmd_info_desc[rg] + ":\texecute success\r\n"
            else:
                fun_err_msg        +=cmd_info_desc[rg] + u":\t执行成功\r\n"
                
                
    cmd_display.put("err_msg", fun_err_msg)
    fun_flag = CHECK_PASS
    return fun_flag, cmd_display, fun_err_msg




