# -*- coding: UTF-8 -*-
cmd_info_id = ["cmd_info_logic_volume_VRTSexplorer",
"cmd_info_hba_card_iSCSI_node",
"cmd_info_os_basic_runlevel",
"cmd_info_os_basic_ip",
"cmd_info_multipath_config",
"cmd_info_multipath_version_emc",
"cmd_info_multipath_path_emc",
"cmd_info_multipath_version_ibm",
"cmd_info_multipath_path_ibm",
"cmd_info_multipath_sys_hds",
"cmd_info_multipath_lu_hds",
"cmd_info_multipath_path_hds",
"cmd_info_multipath_ibmsdddatapath",
]

cmd_info_desc = ["/opt/VRTSspt/VRTSexplorer/VRTSexplorer",
"iscsiadm -m node",
"runlevel",
"ip addr",
"cat /etc/multipath.conf",
"powermt version",
"powermt display dev=all",
"lslpp -L |grep -i sddpcm",
"pcmpath query device",
"dlnkmgr view -sys",
"dlnkmgr view  -lu",
"dlnkmgr view -path",
"rpm -qa|grep -i IBMsdd or /opt/IBMsdd/bin/datapath query version",
]


def execute(context):
    """
    Function name      : execute
    Function describe  : 外部接入
    Input              : context
    Return             : cmd display
    """
    # 给全局变量赋初始值，按照要求传递上下文进去。
    CLI = context.get("SSH")
    LANGUAGE = context.get("lang")
    cmd_display = context.get("ret_map")
    return cmd_execute(cmd_display, CLI, LANGUAGE)


def cmd_execute(cmd_display, CLI, LANGUAGE):
    fun_err_msg = ''

    for rg in range(len(cmd_info_id)):
        cmd_display_temp = CLI.execCmdNoLogTimout(cmd_info_desc[rg], 60)

        cmd_display.put("cmd_display" + (cmd_info_id[rg])[8:], cmd_display_temp)

        if None == cmd_display_temp or '' == cmd_display_temp or cmd_display_temp.find('TOOLKIT_SEND_CMD_TIME_OUT') > 0 or cmd_display_temp.find('TOOLKIT_EXE_CMD_FAILED') > 0:
            if "en" == LANGUAGE:
                fun_err_msg += cmd_info_desc[rg] + ":\texecute failed\r\n"
            else:
                fun_err_msg += cmd_info_desc[rg] + u":\t执行失败\r\n"
        else:
            if "en" == LANGUAGE:
                fun_err_msg += cmd_info_desc[rg] + ":\texecute success\r\n"
            else:
                fun_err_msg += cmd_info_desc[rg] + u":\t执行成功\r\n"
    cmd_display.put("err_msg", fun_err_msg)
    return cmd_display
