# coding=utf-8
__author__ = '******'
# 获取linux主机的一些基础信息:名称、版本、CPU、内存等.
import re
import sys
import os
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..")
sys.path.append(path)
from common import util
from common import constants
CLI = None
LANGUAGE = None
CHECK_FAIL          =       0
CHECK_PASS          =       1
cmd_info_id = ["cmd_info_database_objectchange",
               "cmd_info_database_sqlplus",

               ]
            
cmd_info_desc = ["su - oracle",
                 "sqlplus / as sysdba",
                 
                 ]

sql_info = {"sql_info_cluster_ora_cversion"      :       "select * from v$version;",
            "sql_info_cluster_ora_datafile"      :       "select name from v$datafile;",
            "sql_info_cluster_ora_logmod"         :       "select name,log_mode from v$database;",
            "sql_info_cluster_ora_controlfile"   :       "select name from v$controlfile;",
            "sql_info_cluster_ora_logfile"       :       "select member from v$logfile;",
            "sql_info_cluster_ora_tablespacename"    :       "select tablespace_name,sum(bytes)/1024/1024 M from dba_segments group by tablespace_name;",
            "sql_info_cluster_ora_tablespace_filesize"   :   "select tablespace_name,file_name,bytes from dba_data_files;",
            "sql_info_cluster_ora_diskgroupname"     :       "select group_number,name from v$asm_diskgroup;",
            "sql_info_cluster_ora_diskgroupstate"   :   "select group_number,state from v$asm_diskgroup;",
            "sql_info_cluster_ora_diskgroupcapacity"    :   "select group_number,total_mb from v$asm_diskgroup;",
            "sql_info_cluster_ora_diskgroupall"     :   "select group_number,name,state,total_mb from v$asm_diskgroup;",
            "sql_info_cluster_ora_asminfosome"       :      "select group_number,name,path from v$asm_disk;",
            "sql_info_cluster_ora_asminfoall"       :       "select group_number,disk_number,mount_status,header_status,state,name,path from v$asm_disk;",
            }

def execute(context):
    """
    Function name      : execute
    Function describe  : 外部接入
    Input              : context
    Return             : cmd display
    """
    # 给全局变量赋初始值，按照要求传递上下文进去。
    global CLI
    CLI = context.get("SSH")
    global LANGUAGE
    LANGUAGE = context.get("lang")
    cmd_display = context.get("ret_map")
    return check_and_get_result(cmd_execute(cmd_display, CLI, LANGUAGE,context))


# 取中间一个有效值
def check_and_get_result((fun_flag, result, fun_err_msg)):
    """
    :rtype : object
    """
    return result


def cmd_execute(cmd_display, CLI, LANGUAGE,context):
    fun_flag = CHECK_FAIL
    sql_flag = True
    fun_err_msg = ''
    prgStep = constants.PROG65 / len(cmd_info_id)
    curstep = constants.PROG5
    util.updateItemProgress(context, curstep)
    for rg in range(len(cmd_info_id)):
        cmd_display_temp = CLI.execCmdHasLogTimout(cmd_info_desc[rg],60)
        curstep += prgStep
        util.updateItemProgress(context, curstep)
        cmd_display.put("cmd_display"+(cmd_info_id[rg])[8:], cmd_display_temp)
        if None == cmd_display_temp or '' == cmd_display_temp or cmd_display_temp.find('TOOLKIT_SEND_CMD_TIME_OUT') > 0 or cmd_display_temp.find('TOOLKIT_EXE_CMD_FAILED') > 0 or cmd_display_temp.find('Permission denied') > 0:
            if "en"==LANGUAGE:
                fun_err_msg        +=cmd_info_desc[rg] + ":\texecute failed\r\n"
            else:
                fun_err_msg += cmd_info_desc[rg] + u":\t执行失败\r\n"
            sql_flag = False
        else:
            if "en"==LANGUAGE:
                fun_err_msg        +=cmd_info_desc[rg] + ":\texecute success\r\n"
            else:
                fun_err_msg += cmd_info_desc[rg] + u":\t执行成功\r\n"
    cmd_display.put("err_msg", fun_err_msg)
    if sql_flag:
        for item in sql_info:
            cmd_display_temp = CLI.execDbCmdNoLogTimout(sql_info.get(item),60)
            util.updateItemProgress(context, constants.PROG80)
            cmd_display.put("sql_display"+(item)[8:], cmd_display_temp)
            if None == cmd_display_temp or '' == cmd_display_temp or cmd_display_temp.find('TOOLKIT_SEND_CMD_TIME_OUT') > 0 or cmd_display_temp.find('TOOLKIT_EXE_CMD_FAILED') > 0:
                if "en"==LANGUAGE:
                    fun_err_msg        +=sql_info.get(item) + ":\texecute failed\r\n"
                else:
                    fun_err_msg += sql_info.get(item) + u":\t执行失败\r\n"
            else:
                if "en"==LANGUAGE:
                    fun_err_msg        +=sql_info.get(item) + ":\texecute success\r\n"
                else:
                    fun_err_msg += sql_info.get(item) + u":\t执行成功\r\n"
        cmd_display.put("err_msg", fun_err_msg)
        #退出数据库
        CLI.execDbCmdNoLogTimout("exit", 60)
        CLI.execDbCmdNoLogTimout("exit", 60)
    util.updateItemProgress(context, constants.PROG90)
    fun_flag = CHECK_PASS

    return fun_flag, cmd_display, fun_err_msg