# --*-- coding:utf-8 --*--
import sys 
import os
import re
reload(sys) 
sys.setdefaultencoding('utf-8')
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import *

global key_lst  #对应Excel中属性列表
global attribute_arr #从传入的命令中获取的属性列表 
global  value_lst
global context


#对应excel中的属性字段
key_lst  = [
                'database_name',
                'database_version',
                'data_store_mode',
                'archive_mode',
                'ocr_disks',
                'vote_disks',
                'control_files',
                'logfiles'
            ]

#获取Linux主机集群 Server信息
def execute(context):
    #获取回文
    #start
    path = getValueFMap(context,style,'path')
    command = getValueFMap(context,style,'command').strip()
    attribute_arr = []
    value_lst = []
    if ';'== command[-1]:
        command =command[0:-1]
    addValueToMap(context,style,'command',command)
    #属性名与对应命令组成的列表的字典
    attrcom_dic = get_attrcom_dic(context)
    #对应execel属性名
    json_attr_name = get_jsonarr_name(attrcom_dic)
    attr_valuelst_dic = get_attrvalue_dic(context,attrcom_dic)
    #获取attribute ,value_lst
    for key in key_lst:
        for attr in attr_valuelst_dic.keys():
            if key.lower().strip() in attr.lower():
                attribute_arr.append(attr)
    #检查key_lst
    check_keylst(key_lst,attribute_arr)
    #获取json结果字符串
    #name   
    name_lst = attr_valuelst_dic[attribute_arr[0]]
    database_name = get_name(name_lst)
    #version
    version = get_version(name_lst,database_name)
    #store model
    storemode_lst = attr_valuelst_dic[attribute_arr[2]]
    store_mode = get_storemode(storemode_lst) 
    #archive_mode
    archive_mode_lst = attr_valuelst_dic[attribute_arr[3]]
    archive_mode = get_archivemode(archive_mode_lst)
    #ocr_disks
    ocr_disks_lst = attr_valuelst_dic[attribute_arr[4]]
    ocr_disks = get_orcdisk(ocr_disks_lst)
    #vote_disks
    vote_disks_lst = attr_valuelst_dic[attribute_arr[5]]
    vote_disks = get_votedisks(vote_disks_lst)
    #control_files
    control_files_lst = attr_valuelst_dic[attribute_arr[6]]
    control_files = get_controlfiles(control_files_lst)
    #logfiles
    logfiles_lst = attr_valuelst_dic[attribute_arr[7]]
    logfiles = get_logfiles(logfiles_lst)
    value_lst = [database_name,version,store_mode,archive_mode,ocr_disks,vote_disks,control_files,logfiles]
    #json str
    result = get_jsonstr(json_attr_name,attribute_arr, value_lst)
    addValueToMap(context,style,'result',result)

    return context

#功能说明：返回数据库名字
def get_name(templst):
    name = 'NA'
    if 0 == len(templst):
        return 'NA'
    if not is_success(templst):
        return 'NA'
    if is_belong_lst('oracle',templst):
        name = 'Oracle'
    elif is_belong_lst('mysql', templst):
        name = 'Mysql'
    elif is_belong_lst('sqlserver', templst):
        name = 'SQLServer'
    elif is_belong_lst('db2', templst):
        name = 'DB2'
    return name

#功能说明：返回数据库版本
def get_version(templst,database_name):
    result = 'NA'
    if 0 == len(templst):
        return 'NA'
    if not is_success(templst):
        return 'NA'
    lst = []
    
    for line in templst:
        if database_name.lower() in line.lower():
            return line.strip()
    return result


#功能说明：返回store mode
def get_storemode(templst):
    #dfg+DATA1:(ASM)   /XX/XX.dbf : filesystem， /dev/rhdiskx, RAW   /dev/RAW/RAW1
    #有+号,ASM；后缀.dbf，fs；/dev开头，RAW
    result = 'NA'
    if 0 == len(templst):
        return 'NA'
    if not is_success(templst):
        return 'NA'
    for line in templst:
        if '+' in line:
            result = 'ASM'
            break
        elif '.dbf' in line.lower():
            result = 'filesystem'
            break
        elif '/dev' in line.lower():
            result = 'RAW'
            break
    return result 

#功能说明：返回archive mode
def get_archivemode(tempList):
    result = 'NA'
    if 0 == len(tempList):
        return 'NA'
    if not is_success(tempList):
        return 'NA'
    for line in tempList[1:-1]:
        if 'archivelog' in line.lower():
            tempArray = []
            tempArray = re.split('\\s+', line)
            if len(tempArray) > 1:
                result = tempArray[1]
                return result
    return result
    
#功能说明：返回ocr disks
def get_orcdisk(templst):
    result = 'NA'
    if 0 == len(templst):
        return 'NA'
    if not is_success(templst):
        return 'NA'
    result = LINE_SPLIT_SIGN.join(templst[1:-1])
    return result
#功能说明：返回vote disks
def get_votedisks(templst):
    result = 'NA'
    if 0 == len(templst):
        return 'NA'
    if not is_success(templst):
        return 'NA'
    result = LINE_SPLIT_SIGN.join(templst[1:-1])
    return result

#功能说明：返回controlfiles
def get_controlfiles(templst):
    result = 'NA'
    if 0 == len(templst):
        return 'NA'
    if not is_success(templst):
        return 'NA'
    result = LINE_SPLIT_SIGN.join(templst[1:-1])
    return result

#功能说明：返回logfiles
def get_logfiles(templst):
    result = 'NA'
    if 0 == len(templst):
        return 'NA'
    if not is_success(templst):
        return 'NA'
    result = LINE_SPLIT_SIGN.join(templst[1:-1])
    return result

#功能说明：判断字符串 是否包含于列表中的某项
def is_belong_lst(value,templst):
    result = False
    for line in templst:
        if value.lower().strip() in line.lower():
            result = True 
    return result 

#功能说明：检查key_lst
def check_keylst(key_lst,attribute_arr):
    if not (len(key_lst) == len(attribute_arr)):
        raise Exception("key lst Error")


#功能说明：返回属性名与回文列表之字典
def get_attrvalue_dic(context,attrcom_dic):
    all_comds_lst = get_purecommands_lst(attrcom_dic)
    path = getValueFMap(context,style,'path')
    all_comds_byfile = get_comdslst_byfile(all_comds_lst,path)
    
    return get_attrlst_dic(attrcom_dic,all_comds_byfile,path)

class Data_Base_Info:
    __name = 'NA'
    __version = 'NA'
    __store_mode = 'NA'
    __archive_mode = 'NA'
    __ocr_disks = 'NA'
    __vote_disks = 'NA'
    __control_files = 'NA'
    __logfiles = 'NA'
    def set_name(self,name):
        self.__name = name
    def set_version(self,ver):
        self.__version = ver
    def set_storemodel(self,model):
        self.__store_mode = model
    def set_archivemode(self,model):
        self.__archive_mode = model
    def set_orcdisks(self,disks):
        self.__ocr_disks = disks
    def set_votedisks(self,disks):
        self.__vote_disks = disks
    def set_contrlfiles(self,files):
        self.__control_files = files
    def set_logfiles(self,files):
        self.__logfiles = files
    def get_name(self):
        return self.__name
    def get_version(self):
        return self.__version
    def get_storemodel(self):
        return self.__store_mode
    def get_archivemodel(self):
        return self.__archive_mode
    def get_ocrdisks(self):
        return self.__ocr_disks
    def get_votedisks(self):
        return self.__vote_disks
    def get_contrlfiles(self):
        return self.__control_files
    def get_logfiles(self):
        return self.__logfiles
