# --*-- coding:utf-8 --*--
import sys 
import os
import re
from cmd import Cmd
reload(sys) 
sys.setdefaultencoding('utf-8')
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import *

global key_lst  #对应Excel中属性列表
global attribute_arr #从传入的命令中获取的属性列表 
global  value_lst
global context

#对应excel中的属性字段
key_lst = ["server_model","cpu_model","memory","os","multipath","cluster","lvm/vxvm","database"]

#获取Linux主机集群 Server信息
def execute(context):
    #获取回文
    #start
    path = getValueFMap(context,style,'path')
    command = getValueFMap(context,style,'command').strip()
    attribute_arr = []
    value_lst = []

    addValueToMap(context,style,'command',command)
    #属性名与对应命令列表组成的字典
    attrcom_dic = get_attrcom_dic(context)
    
    #对应execel属性名
    json_attr_name = get_jsonarr_name(attrcom_dic)
    attr_valuelst_dic = get_attrvalue_dic(context,attrcom_dic)
    #获取attribute ,value_lst
    
    for key in key_lst:
        tempList = []
        for attr in attr_valuelst_dic.keys():
            if key.lower().strip() in attr.lower():
                attribute_arr.append(attr)
                tempList = attr_valuelst_dic[attr]
                value = get_value_bykey(tempList,key)
                value_lst.append(value)
    #获取json结果字符串                
    result = get_jsonstr(json_attr_name,attribute_arr, value_lst)
    addValueToMap(context,style,'result',result)
    return context


#功能说明：返回属性名与对应回文组成的字典
def get_attrvalue_dic(context,attrcom_dic):
    all_comds_lst = get_purecommands_lst(attrcom_dic)
    path = getValueFMap(context,style,'path')
    all_comds_byfile = get_comdslst_byfile(all_comds_lst,path)
    return get_attrlst_dic(attrcom_dic,all_comds_byfile,path)

 
#功能说明：返回Server model
def get_servermodel(tempList):
    result = 'NA'
    if 0==len(tempList):
        return 'NA'
    length = len(tempList)
    index = 0 
    for i in range(length):
        if "uname -a" in tempList[i]:
            index = i +1
            break
    try:
        result = tempList[index].split()[1]
    except:
        result = 'NA'
    return result

#功能说明：返回CPU model    
def get_cpumodel(tempList):
    #架构 厂商，位数。如：x86-64 AMD64
    arch = 'NA'
    vendor = 'NA'
    osbit = 'NA'
    
    if 0==len(tempList):
        return 'NA'
    result = ""
    tempList = checktempList(tempList)
    for i,line in enumerate(tempList):
        if 'isainfo' in line.lower():
            arch = tempList[i+1].strip()
            break
    for i,line in enumerate(tempList):
        if ('isainfo' in line.lower()) and ('-b' in line.lower()):
            osbit = tempList[i+1]
            break
    result = arch+' '+vendor+osbit
    
    return result 

#功能说明：返回Memory 
def get_memory(tempList):
    if 0==len(tempList):
        return 'NA'
    
    result=""
    strtemp=""
    for i in range(len(tempList)):
        if "Memory size" in tempList[i]:
            strtemp=tempList[i]
    strtemp=strtemp.split()[2]
    fmem=int(strtemp)*1.0
    fmem=fmem/1024.0
    fmem=round(fmem,2)
    result=str(fmem)
    result=result+" GB"

    return result 

#功能说明：返回Multipath
def get_multipath(tempList):
    multipath_name = "NA"
    if 0 == len(tempList):
        return  multipath_name
    
    txtList = []
    index = 0
    for i,line in enumerate(tempList):
        if divide in line:
            txtList.append(tempList[index:i])
            index = i + 1
    
    failStr = fail_flag
    
    resultTxt = []
    
    for txtBlock in txtList:
        flag = True
        for line in txtBlock:
            if failStr.lower() in line.lower():
                flag = False
                break
        if flag:
            resultTxt = txtBlock
            
    if len(resultTxt) == 0:
        return  multipath_name
    
    for line in resultTxt:
        if 'stmsboot' in line:
            multipath_name= 'Sun StorEdge Traffic Manager Software'
        if 'mpathadm' in line:
            multipath_name= 'Sun StorEdge Traffic Manager Software'
        if 'powermt' in line:
            multipath_name='PowerPath'
        if 'upadmin' in line:
            multipath_name='UltraPath'
        if 'dlnkmgr' in line:
            multipath_name='HDLM'
        if 'upadm' in line:
            multipath_name='UltraPath'
    return multipath_name
    
    
def get_cluster(tempList):
    result = ""
    if 0==len(tempList):
        return 'NA'
    result = '\\n'.join(tempList[1:-1])
    return result
    
    
#功能说明：返回lvm/vxvm
def get_lvm(tempList):
    result = ""
    
    if 0==len(tempList):
        return 'NA'
    
    for i,value in enumerate(tempList):
        if ('lvm' in value.lower()) and ('version:' in value.lower()):
            result = tempList[i]
            break
    result = result.split(':')[1].strip()
    if ""!= result.lower():
        return result
    
    result = '\\n'.join(tempList[1:-1])
    return result 
    


def get_database(tempList):
    result = ""
    if 0==len(tempList):
        return 'NA'
    else:
        result = '\\n'.join(tempList[1:-1])
    return result 

#功能说明：返回OS
def get_os(tempList):
    tempList = tempList [2:-1]
    if 0 == len(tempList):
        return 'NA'
    try:
        tempstr0=tempList[0].split()[0]
        tempstr1=tempList[0].split()[2]
        result=tempstr0+" "+tempstr1
    except:
        result = 'not foud'
    return result

def get_value_bykey(tempList,key):
    if key == key_lst[0]:
        return get_servermodel(tempList)
    elif key == key_lst[1]:
        return get_cpumodel(tempList)
    elif key == key_lst[2]:
        return get_memory(tempList)
    elif key == key_lst[3]:
        return get_os(tempList)
    elif key == key_lst[4]:
        return get_multipath(tempList)
    elif key == key_lst[5]:
        return get_cluster(tempList)
    elif key == key_lst[6]:
        return get_lvm(tempList)
    elif key == key_lst[7]:
        return get_database(tempList)
    else:
        return "Key Error"
    
class multipath_Entity:
    __mul_name = 'NA'
    __mul_version = 'NA'
    __mul_status = 'NA'
    
    def get_name(self):
        return self.__mul_name
    def get_version(self):
        return self.__mul_version
    def get_status(self):
        return self.__mul_status
    
    def set_name(self,name):
        self.__mul_name = name
    def set_version(self,version):
        self.__mul_version = version
    def set_status(self,status):
        self.__mul_status = status
