# coding=utf-8
import sys
import os
path = os.path.dirname(os.path.abspath(__file__))
sys.path.append(path)
path = os.path.join(path, "..\\..")
sys.path.append(path)
from common import constants
from common import util
from windows_hbatmo_collect import hbaTmoExecute

CLI = None
LANGUAGE = None
CHECK_FAIL = 0
CHECK_PASS = 1
cmdInfoId = ["cmd_info_hba_card_controller",
             "cmd_info_hba_card_system_version",
             "cmd_info_hba_card_wwpn"]
            
cmdInfoDesc = ["wmic scsicontroller",
               "wmic OS get Version /value",
               "mode con cols=281&powershell Get-InitiatorPort",
               "winrm e wmi/root/wmi/MSFC_FibrePortHBAAttributes"]

def execute(context):
    """
    Function name      : execute
    Function describe  : 外部接入
    Input              : context
    Return             : cmd display
    """
    # 给全局变量赋初始值，按照要求传递上下文进去。
    global CLI
    CLI = context.get("SSH")
    global LANGUAGE
    LANGUAGE = context.get("lang")
    global uiUpdater
    uiUpdater = context.get("uiObsver")
    cmdDisplay = context.get("ret_map")
    cmdExecute(context, cmdDisplay, CLI, LANGUAGE)
    
    cmdDisplayHbaTmo = hbaTmoExecute(context)
    uiUpdater.updateProgress(constants.PROG95)
    return cmdDisplayHbaTmo
    
    
def cmdExecute(context, cmdDisplay, CLI, LANGUAGE):
    funErrMsg = ''
    funErrMsg, cmdDisplay = getCmdResult(funErrMsg, cmdDisplay, CLI.execCmd(cmdInfoDesc[0]), cmdInfoId[0], cmdInfoDesc[0])
    util.updateItemProgress(context, constants.PROG10)
    cmdDisplayTemp = CLI.execCmd(cmdInfoDesc[1])
    funErrMsg, cmdDisplay = getCmdResult(funErrMsg, cmdDisplay, cmdDisplayTemp, cmdInfoId[1], cmdInfoDesc[1])
    if judgeVersionNew(context, cmdDisplayTemp):
        funErrMsg, cmdDisplay = getCmdResult(funErrMsg, cmdDisplay, CLI.execCmd(cmdInfoDesc[2]), cmdInfoId[2], cmdInfoDesc[2])
    else:
        funErrMsg, cmdDisplay = getCmdResult(funErrMsg, cmdDisplay, CLI.execCmd(cmdInfoDesc[3]), cmdInfoId[2], cmdInfoDesc[3])

    cmdDisplay.put("err_msg", funErrMsg)
    

def getCmdResult(funErrMsg, cmdDisplay, cmdDisplayTemp, cmdInfoTemp, cmdInfoDescTemp):   
    cmdDisplay.put("cmd_display" + (cmdInfoTemp)[8:], cmdDisplayTemp)
    if None == cmdDisplayTemp or '' == cmdDisplayTemp or cmdDisplayTemp.find('TOOLKIT_SEND_CMD_TIME_OUT') > 0 or cmdDisplayTemp.find('TOOLKIT_EXE_CMD_FAILED') > 0:
        if "en" == LANGUAGE:
            funErrMsg += cmdInfoDescTemp + ":\texecute failed\r\n"
        else:
            funErrMsg += cmdInfoDescTemp + u":\t执行失败\r\n"
    else:
        if "en" == LANGUAGE:
            funErrMsg += cmdInfoDescTemp + ":\texecute success\r\n"
        else:
            funErrMsg += cmdInfoDescTemp + u":\t执行成功\r\n"
    return funErrMsg, cmdDisplay

def judgeVersionNew(context, cmdDisplayTemp):
    if len(cmdDisplayTemp.splitlines()) >= 2:
        line = cmdDisplayTemp.splitlines()[1]
        if "version" in line.lower() and "=" in line and "." in line:
            versionNum = line.split("=")[-1].split(".")
            try:
                if int(versionNum[0].strip()) > 6:
                    return True
                elif int(versionNum[0].strip()) == 6 and int(versionNum[1].strip()) >= 2:
                    return True
                else:
                    return False
            except:
                util.log.error(context, "transform to int type fail!")
                return False
    else:
        util.log.debug(context, "the return result is abnormal!")
        return False
