# coding=utf-8
__author__ = '******'
# 获取linux主机的一些基础信息:名称、版本、CPU、内存等.
import re
import sys
import os
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..")
sys.path.append(path)
from common import util
from common import constants
CLI = None
LANGUAGE = None
CHECK_FAIL = 0
CHECK_PASS = 1
cmd_info_id = ["cmd_info_os_name"                  ,
               "cmd_info_os_version"               ,
               "cmd_info_COMPUTERSYSTEM_Model"     ,
               "cmd_info_COMPUTERSYSTEM_SystemType",
               "cmd_info_COMPUTERSYSTEM_Name"      ,
               "cmd_info_COMPUTERSYSTEM_Manufacturer",
               "cmd_info_cpu_Name",
               "cmd_info_cpu_Amount",
               "cmd_info_os_WindowsDirectory"      ,
               "cmd_info_os_SystemDirectory"       ,
               "cmd_info_os_BootDevice"            ,
               "cmd_info_os_MemorySize",
               "cmd_info_os_SerialNumber",
               "cmd_info_ipconfig"]
            
cmd_info_desc = ["wmic OS get Caption /value",
                 "wmic OS get Version, CSDVersion, BuildNumber /value",
                 "wmic COMPUTERSYSTEM get Model /value",
                 "wmic COMPUTERSYSTEM get SystemType /value",
                 "wmic COMPUTERSYSTEM get Name /value",
                 "wmic COMPUTERSYSTEM get manufacturer /value",
                 "wmic cpu get name /value",
                 "wmic computersystem get NumberOfProcessors /value",
                 "wmic OS get WindowsDirectory /value",
                 "wmic OS get SystemDirectory /value",
                 "wmic OS get BootDevice /value",
                 "wmic OS get FreePhysicalMemory,TotalVisibleMemorySize /value",
                 "wmic os get SerialNumber /value",
                 "wmic nicconfig get IPAddress"]
                 


def execute(context):
    """
    Function name      : execute
    Function describe  : 外部接入
    Input              : context
    Return             : cmd display
    """
    # 给全局变量赋初始值，按照要求传递上下文进去。
    global CLI
    CLI = context.get("SSH")
    global LANGUAGE
    LANGUAGE = context.get("lang")
    cmd_display = context.get("ret_map")

    return check_and_get_result(cmd_execute(cmd_display, CLI, LANGUAGE, context))


# 取中间一个有效值
def check_and_get_result((fun_flag, result, fun_err_msg)):
    """
    :rtype : object
    """
    return result


def cmd_execute(cmd_display, CLI, LANGUAGE, context):
    fun_flag = CHECK_FAIL
    fun_err_msg = ''
    prgStep = constants.PROG85 / len(cmd_info_id)
    curstep = constants.PROG5
    util.updateItemProgress(context, curstep)
    for rg in range(len(cmd_info_id)):
        cmd_display_temp = CLI.execCmd(cmd_info_desc[rg])
        curstep += prgStep
        util.updateItemProgress(context, curstep)
        cmd_display.put("cmd_display" + (cmd_info_id[rg])[8:], cmd_display_temp)
        if None == cmd_display_temp or '' == cmd_display_temp or cmd_display_temp.find('TOOLKIT_SEND_CMD_TIME_OUT') > 0 or cmd_display_temp.find('TOOLKIT_EXE_CMD_FAILED') > 0:
            if "en" == LANGUAGE:
                fun_err_msg += cmd_info_desc[rg] + ":\texecute failed\r\n"
            else:
                fun_err_msg += cmd_info_desc[rg] + u":\t执行失败\r\n"
        else:
            if "en" == LANGUAGE:
                fun_err_msg += cmd_info_desc[rg] + ":\texecute success\r\n"
            else:
                fun_err_msg += cmd_info_desc[rg] + u":\t执行成功\r\n"
    cmd_display.put("err_msg", fun_err_msg)
    fun_flag = CHECK_PASS
    return fun_flag, cmd_display, fun_err_msg
