# -*- coding: UTF-8 -*-
import os
import sys
import traceback
CURRENT_PATH = os.path.dirname(os.path.abspath(__file__))
sys.path.append(CURRENT_PATH)
CURRENT_PATH = os.path.join(CURRENT_PATH, "..\\..")
sys.path.append(CURRENT_PATH)
from lib.netapp_processor import NetAppProcessor
cmd_list = ['system-get-version',
            'system-get-node-info-iter',
            'system-get-info']
CMD_ERROR = '<RESULT_ERROR>'
RESULT_SUCC = "0"
RESULT_FAILED = "126"
def execute(context):
    '''
    :entrance
    '''
    connector = context.get("connector")
    connector.clearEchoValue()
    connection_settings = connector.getSettings()
    logger = context.get("Logger")
    cmd_display = context.get("ret_map")
    language = context.get("lang")
    netapp_instance = NetAppProcessor(connection_settings, logger)
    result_msg = ''
    fun_err_msg = ''
    for cmd in cmd_list:
        cmd_param = cmd.strip().split()

        try:
            if len(cmd_param) < 2:
                result_msg = netapp_instance.simply_invoke(cmd_param[0]) if len(cmd_param) > 0 else ''
            else:
                result_msg = netapp_instance.simply_invoke(cmd_param[0], cmd_param[1:])
                logger.info(str(result_msg))
            result_msg = check_result_msg(result_msg)
            cmd_display.put("cmd_display_" + cmd, str(result_msg))
            if "en" == language:
                fun_err_msg += cmd + ":\texecute success\r\n"
            else:
                fun_err_msg += cmd + u":\t执行成功\r\n"
        except BaseException, excp:
            logger.error("exception occurred while fetching netapp info: " + str(excp))
            logger.error(traceback.format_exc())
            connector.setEchoValue(cmd, RESULT_FAILED)
            if "en" == language:
                fun_err_msg += cmd + ":\texecute failed\r\n"
            else:
                fun_err_msg += cmd + u":\t执行失败\r\n"

        cmd_display.put("err_msg", fun_err_msg)

    return cmd_display

def check_result_msg(msg):
    """
    check whether the result is success or failed , if failed , encapsulate messages
    """
    is_result_pass = False
    for line in msg.splitlines():
        if '<results' in line and 'status=':
            chars = line[line.find('status='):].split()[0]
            if 'pass' in chars:
                is_result_pass = True
    if not is_result_pass:
        msg += CMD_ERROR

    return msg
